const RB_PATTERN = 'rb(\\d*)'
const RP_PATTERN = 'rp(\\d*)'

module.exports = ({ roll }) => ({
  id: 'io.paotuan.plugin.coc.realrbrp',
  name: 'COC 真实奖惩骰',
  version: 1,
  aliasRoll: [
    {
      id: 'rb',
      name: 'COC 真实奖励骰',
      trigger: 'regex',
      command: RB_PATTERN,
      replacer: (match) => {
        const count = parseInt(match[1] || '1') || 1 // 奖励骰个数
        const unit = roll('1d10-1').total
        const tens = new Array(count + 1).fill(0).map(() => roll('1d10-1').total)
        const finals = tens.map(ten => {
          let res = 10 * ten + unit
          if (res === 0) res = 100
          return res
        })
        return `{${finals.join(',')}}kl1`
      }
    },
    {
      id: 'rp',
      name: 'COC 真实惩罚骰',
      trigger: 'regex',
      command: RP_PATTERN,
      replacer: (match) => {
        const count = parseInt(match[1] || '1') || 1 // 惩罚骰个数
        const unit = roll('1d10-1').total
        const tens = new Array(count + 1).fill(0).map(() => roll('1d10-1').total)
        const finals = tens.map(ten => {
          let res = 10 * ten + unit
          if (res === 0) res = 100
          return res
        })
        return `{${finals.join(',')}}kh1`
      }
    }
  ]
})
